﻿Imports System.Runtime.CompilerServices

Public Module Extensions

   <Extension()> _
   Public Sub ForEach(Of T)(ByVal Subj As IEnumerable, ByVal Action As Action(Of T))
      For Each itm As T In Subj
         Action(itm)
      Next
   End Sub

   <Extension()> _
   Public Function ParentTables(ByVal Tb As DataTable) As IEnumerable(Of DataTable)
      Return From Rl In Tb.ParentRelations.Cast(Of DataRelation)() Select Rl.ParentTable
   End Function

   <Extension()> _
   Public Function GetRankedTables(ByVal dts As DataSet) As List(Of DataTable)
      Dim jobs = New HashSet(Of DataTable)(dts.Tables.Cast(Of DataTable))
      GetRankedTables = New List(Of DataTable)(jobs.Count) 'Ergebnisliste
      'anonyme rekursive Methode:
      'Bevor ein Node aus dem Hashset in die Ergebnisliste verschoben wird,
      ' werden rekursiv all seine Vorgänger verschoben
      Dim recurse As Action(Of DataTable) = Nothing
      recurse = Sub(tb)
                   If Not jobs.Remove(tb) Then Return 'Abbruch-Bedingung trifft bei Kreisbezügen zu
                   tb.ParentTables.ForEach(recurse) 'Rekursion mit jeder ParentTable bevor ...
                   GetRankedTables.Add(tb) '... Verschiebung in Ergebnisliste
                End Sub
      While jobs.Count > 0
         recurse(jobs.First)
      End While
   End Function

End Module
